
#define adr(var) ldx #var % 256\ ldy #var / 256
            ; load xreg lobyte address  and yreg with hibyte
#define asl asl a
#define rol rol a
#define ror ror a
#define lsr lsr a

;P*--------------------------------------
;* BASIC header.  Put this at the start
;* of a program to be able to "RUN" it.
;--------------------------------------
        .ORG $1C01-2
        .WORD $1C01
        .WORD TWOBRK
        .WORD  1993 ;Line number 1993
        .BYTE  $9E ;SYS token
        .TEXT 7240:
        .BYTE $8F,$22,$8D,$91,$12,$0E     ;control codes to
                    ;hide basic line
QWKRR   .TEXT "qwkrr128 cALC REGISTRATION (c) r.gASSON 1992/93"
        .BYTE 0  ;BRK  ;End of basic line
TWOBRK  .FILL 2,0   ;End of basic program
        .FILL  $1C48-*, 0

        JMP ST

FREE = $FA
MYID  .TEXT "    qwkrr128 v3"
NUMTBL .WORD 1,10,100,1000,10000
STRING  .FILL  30, 0
BLKTXT  .FILL 10, 0
PRTR     .FILL 1, 0    ;DS 1 ;0 screen <> asc printer
;*-------------------------------
;* kernal stuff & macros

SETBNK = $FF68
PRIMM = $FF7D
ACPTR = $FFA5
CHKIN = $FFC6
CHKOUT = $FFC9
CHROUT = $FFD2
CLOSE = $FFC3
CLALL = $FFE7
CLRCHN = $FFCC
GETIN = $FFE4 ;input from buffer
OPEN = $FFC0
SETLFS = $FFBA
SETNAM = $FFBD
PLOT = $FFF0
INDFET = $FF74
INDSTA = $FF77
INDCMP = $FF7A
TALK = $FFB4
TKSA = $FF96
UNTLK = $FFAB
STOP = $FFE1
SCROLL = $F8
SA = $B9
STATUS = $90

;*-------------------------------
ST JSR PRIMM
 .BYTE 147, 14
 .TEXT "cALCULATE qwkrr128 REGISTRATION NUMBERS."
 .BYTE 13
 .TEXT "(ENTER NAMES IN UPPER LOWER CASE FORMAT)"
 .BYTE 13,13
 .TEXT "nAME  :"
 .BYTE 0

 LDX #25
 LDA #0
 STA FREE
 STA PRTR
 JSR GETLINE
 LDA FREE
 BNE _DO
 RTS


_DO JSR PRIMM
 .BYTE 13
 .TEXT "cODE  :"
  .BYTE 0
 JSR SHOW
 JMP ST
;*-------------------------------

GETLINE STX FREE+3

 LDA #0
 STA FREE+2
 LDA FREE
 BNE _PRE
 LDY #0
 LDA #160
 STA STRING,Y
 BNE _LESS

_PRE LDY FREE
 CPY FREE+3
 BCC _OKK
 LDY FREE+3
 DEY
 STY FREE

_OKK LDA STRING,Y
 BNE _NOTNUL
 LDA #' '
 STA STRING,Y
_NOTNUL CMP #' '
 BNE _TT
_S DEC FREE
 BNE _PRE

_TT CMP #13
 BEQ _S
 CMP #160
 BEQ _S

_TXT LDA FREE
 CMP FREE+3
 BCC _LESS
 LDY FREE+3
 DEY
 STY FREE

_LESS INC FREE
 LDY FREE
 LDA #160
 STA STRING,Y
 LDY FREE+3
 STA STRING,Y

 LDY FREE
 CPY #1
 BEQ ASK

 LDY #0
_PRT LDA STRING,Y
 JSR CHROUT
 INY
 CPY FREE
 BNE _PRT

 LDA #157
_BACK JSR CHROUT
 DEY
 BNE _BACK

ASK JSR GETIN  ; get char
 BEQ ASK  ;no chr loop
 CMP #$0d  ; finish ?
 BNE  _NOFIN
 LDY FREE
 LDA #160
 STA STRING,Y
 JMP _NMDONE

_NOFIN CMP #157
 BNE _NOTLFT
 JMP LLEFT
_NOTLFT CMP #29
 BNE _NOTR
 JMP LRIGHT
_NOTR CMP #20
 BNE _NOTDEL
 JMP LDEL
_NOTDEL CMP #148
 BNE _TEST
 JMP LINST
;special cases test here
_TEST JSR AZTEST
 BEQ ASK
 LDY FREE+2
 STA STRING,Y
 JSR CHROUT
 INC FREE+2
 LDY FREE+2
 CPY FREE+3
 BCC _NOTMAX
 LDA #7
 JSR CHROUT
 LDA #157
 JSR CHROUT
 LDY FREE+3
 INY
 LDA #160
 STA STRING,Y
 DEY
 STY FREE
 DEY
 STY FREE+2
_JMP JMP ASK

_NOTMAX CPY FREE
 BCC _JMP
 BEQ  _JMP

 INC FREE
 LDY FREE
 LDA #160
 STA STRING,Y
 BNE _JMP

_NMDONE
 LDY #0
_CC LDA STRING,Y
 CMP #160
 BEQ _BB
 INY
 BNE _CC

_BB STY FREE
 LDA #160
 STA STRING,Y
 CPY #0
 BEQ _TOFAR
 DEY
 LDA STRING,Y
 CMP #' '
 BEQ _BB
 CMP #160
 BEQ _BB
 INY
_TOFAR STY FREE
 RTS
;*-------------------------------
LLEFT    ;cursor left
 LDY FREE+2
 BNE _CANL
 LDA #7
 JSR CHROUT
 JMP ASK

_CANL DEC FREE+2
 JSR CHROUT
 JMP ASK
;*-------------------------------
LRIGHT LDY FREE+2
 INY
 CPY FREE+3
 BNE _CANR
 LDA #7
 JSR CHROUT
 JMP ASK

_CANR CPY FREE
 BCC _NORM
 BEQ  _NORM
 INC FREE
 LDY FREE
 DEY
 LDA #' '
 STA STRING,Y
 INY
 STA STRING,Y

_NORM INC FREE+2
 JSR CHROUT
 JMP ASK
;*-------------------------------
LDEL    ;cursor left
 LDY FREE+2
 CPY FREE
 BNE _DL
 CPY #0
 BNE _NOTF
 LDA #7
 JSR CHROUT
 JMP ASK

_NOTF LDA #157
 JSR CHROUT
 LDA #' '
 JSR CHROUT
 LDA #157
 JSR CHROUT
 DEC FREE+2
 DEC FREE
 JMP ASK

_DL INY
 LDA STRING,Y
 DEY
 STA STRING,Y
 INY
 JSR CHROUT
 CPY FREE
 BCC _DL

_ES DEC FREE
 LDY FREE+2
 DEY
 LDA #157

_TBACK INY
 CPY FREE
 BEQ _OU
 JSR CHROUT
 BNE _TBACK
_OU JSR CHROUT
 JMP ASK
;*-------------------------------
LINST
 LDA #' '
 STA FREE+1
 LDY FREE+2

_L LDA STRING,Y
 PHA
 LDA FREE+1
 STA STRING,Y
 JSR CHROUT
 PLA
 STA FREE+1
 INY
 CPY FREE+3
 BCC _TDO
 LDA #7
 JSR CHROUT
 BNE _Z

_TDO CPY FREE
 BCC _L
 BEQ _L
_Z LDY FREE+2
 DEY
 LDA #157

_L2 INY
 CPY FREE
 BEQ _DD
 JSR CHROUT
 BNE _L2

_DD LDA FREE
 CMP FREE+3
 BEQ _NOM
 INC FREE
 LDA #157
 JSR CHROUT
_NOM JMP ASK

;*-------------------------------
SHOW LDY #0
_LOOP LDA STRING,Y
 PHA
 AND #%10000000
 BEQ _N1
 PLA
 ORA #%00100000
 AND #%01111111
 PHA
; STA INT
 STA STRING+29
_N1 PLA
 STA STRING,Y
 INY
 CPY FREE
 BNE _LOOP


_RT LDA #32
_PAD CPY #25
 BCS _EOL
 STA STRING,Y
 INY
 BNE _PAD

_EOL LDY #25
 LDA #13
 STA STRING,Y

CHKDP  LDY #0
 STY FREE
 STY FREE+1
 CLC
_FREE   LDA STRING,Y
 CMP #13
 BEQ _CRCO
 CMP #' '
 BNE _NN
 LDA #$FF
_NN ADC FREE
 BCC _DBC
 INC FREE+1
_DBC   STA FREE
 INY
 BNE _FREE
_CRCO   LDY #12
_IDL   LDA MYID-1,Y
 ADC FREE
 BCC _ID
 INC FREE+1
_ID   STA FREE
 DEY
 CPY #4
 BNE _IDL

 LDA FREE
 STA FREE+3
 LDA FREE+1
 STA FREE+4
;*-------------------------------
_PRINT LDA #1
 STA MYID
 LDA #0
 LDX STRING+29
 LDY #5
 JSR PRDEC

 LDY #2
_LOOP1 LDA BLKTXT,Y
 JSR CHROUT
 DEY
 BPL _LOOP1

 LDA #1
 STA MYID
 LDA #0
 LDX STRING
 LDY #5
 JSR PRDEC

 LDY #2
_LOOP2 LDA BLKTXT,Y
 JSR CHROUT
 DEY
 BPL _LOOP2

 LDA #1
 STA MYID
 LDA #0
 LDX FREE+4
 LDY #5
 JSR PRDEC

 LDY #2
_LOOP3 LDA BLKTXT,Y
 JSR CHROUT
 DEY
 BPL _LOOP3

 LDA #1
 STA MYID
 LDA #0
 LDX FREE+3
 LDY #5
 JSR PRDEC

 LDY #2
_LOOP4 LDA BLKTXT,Y
 JSR CHROUT
 DEY
 BPL _LOOP4

;*-------------------------------
;* print crc and initial
 LDA #0
 STA MYID
 LDA PRTR
 BEQ _SC1
 JSR PRIMM
 .BYTE 13
 .TEXT "Check :"
  .BYTE 0
 BNE _SKP

_SC1 JSR PRIMM
 .BYTE 13
 .TEXT "cHECK :"
 .BYTE 0
_SKP LDX FREE+3
 LDA FREE+4
 LDY #9
 JSR  PRDEC
 LDA #' '
 JSR CHROUT

 LDA PRTR
 BEQ _SC2
 LDA STRING
 TAY
 LDA PETTAB,Y
 JSR CHROUT
 LDA STRING+29
 TAY
 LDA PETTAB,Y
 JSR CHROUT
 JMP _OUT

_SC2 LDA STRING
 JSR CHROUT
 LDA STRING+29
 JSR CHROUT

_ZZ JSR GETIN
 BEQ _ZZ
 CMP #'P'
 BNE _OUT
 LDA #0
 adr(HSH)
; LDX #<_HSH
; LDY #>_HSH
 JSR $FFBD
 LDX #0
 JSR $FF68
 LDA #4
 LDX #4
 LDY #7
 JSR $FFBA
 JSR $FFC0
 BCS _PERR
 LDX #4
 STX PRTR
 JSR CHKOUT
 JSR PRIMM
 .TEXT "Name  :"
 .BYTE 0
 LDY #0
 LDX #25
_PL LDA STRING,Y
 STY FREE
 TAY
 LDA PETTAB,Y
 JSR CHROUT
 LDY FREE
 INY
 DEX
 BNE _PL
 LDA #13
 JSR CHROUT
 JSR PRIMM
 .TEXT "Code  :"
 .BYTE 0
 JMP _PRINT

_OUT LDA #13
 JSR CHROUT
 JSR CHROUT
 LDA #4
 JSR $FFC3 ;close
 JSR CLRCHN
 RTS
HSH .BYTE '#'
_PERR JSR CLRCHN
 JSR PRIMM
 .TEXT "pRINTER ERROR"
 .BYTE 0
_TZ JSR GETIN
 BEQ _TZ
 RTS

;*-----------------------------------------

PRDEC STA FREE+2 ;Store number hi
 STX FREE+1 ; & low
 STY FREE
 LDX FREE ;Index for no# digits
; STX FREE
LOAD0 LDY #$b0           ;#"0"  ;Numeric offset
MKDEC LDA FREE+1 ;Repeated subtractions
 CMP NUMTBL-1,X
 LDA FREE+2
 SBC NUMTBL,X
 BCC MKD2 ;Branch if overflow
 STA FREE+2 ;Do the subtract
 LDA FREE+1
 SBC NUMTBL-1,X
 STA FREE+1
 INY ;Count quotient digit
 BNE MKDEC ;Always taken
MKD2 TYA ;Get quotient digit
 DEX ;Point to smaller power of 10
 BEQ PRDC ;Print digit if last one
 CMP #$b0    ;'0' ;Possible leading zero?
 BEQ MKD3 ;Branch if so
 STA FREE ;Flag number started
MKD3 BIT FREE ;Was a digit printed?
 BPL NXTX
PRDC AND #$7F ;Mask high bit
 PHA ;save for a sec -
 LDA MYID ;print or save ?
 BEQ PRT ;0 so print
 STY MYID+1 ;else save y reg
 TAY ;prsav into Y
 DEY ; minus one for index
 PLA ;recover acc
 STA BLKTXT,Y ;and store it
 LDY MYID+1 ;recover y
 INC MYID ;increment pointer
 BNE NXTX ;get next
PRT PLA  ;and acc
 JSR CHROUT ;Send digit
NXTX DEX ;Point to next digit
 BPL LOAD0 ;Loop till done

_TST LDA MYID
 BEQ _O1
 CMP #4
 BEQ _O1
 LDY #2
_M1 LDA BLKTXT,Y
 STA BLKTXT+1,Y
 DEY
 BPL _M1
 LDA #'0'
 STA BLKTXT
 INC MYID
 BNE _TST
_O1 RTS

;* checks for printable characters
;* if out of range then convert to null

AZTEST
 RTS
 CMP #13
 BEQ _OK
 CMP #32
 BCC _ERR
 CMP #128
 BCC _OK
 CMP #193
 BCC _ERR
 CMP #219
 BCC _CONV
 CMP #222 ;shft up arrow
 BNE _NU
 LDA #126
 BNE _OK
_NU LDA #7
 JSR CHROUT
 BNE _ERR
_CONV ;convert hibyte set to low byte set
 AND #%01111111
 ORA  #%00100000  ;
 BNE _OK

_ERR LDA #0
_OK RTS
;********************************
;*ascii to pet
ASCTAB .BYTE 000 ;placeholder for offset
 .BYTE  000,000,000,000,000,000,000,000  ;8
 .BYTE  000,000,000,000,000,000,000,000  ;16
 .BYTE 000,000,000,000,000,000,000,000  ;24
 .BYTE 000,000,000,000,000,000,000,032  ;32
 .BYTE 033,034,035,036,037,038,039,040  ;40
 .BYTE 041,042,043,044,045,046,047,048  ;48
 .BYTE 049,050,051,052,053,054,055,056  ;56
 .BYTE 057,058,059,060,061,062,063,064  ;64

 .BYTE 097,098,099,100,101,102,103,104  ;72
 .BYTE 105,106,107,108,109,110,111,112  ;80
 .BYTE 113,114,115,116,117,118,119,120  ;88
 .BYTE 121,122,091,092,093,094,095,063  ;96
 .BYTE 065,066,067,068,069,070,071,072  ;104
 .BYTE 073,074,075,076,077,078,079,080  ;112
 .BYTE 081,082,083,084,085,086,087,088  ;120
 .BYTE 089,090,091,092,093,126,095,000  ;128

 .BYTE  000,000,000,000,000,000,000,000  ;136
 .BYTE  000,000,000,000,000,000,000,000  ;144
 .BYTE  000,000,000,000,000,000,000,000  ;152
 .BYTE  000,000,000,000,000,000,000,000  ;160
 .BYTE  000,000,000,000,000,000,000,000  ;168
 .BYTE  000,000,000,000,000,000,000,000  ;176
 .BYTE  000,000,000,000,000,000,000,000  ;184
 .BYTE  000,000,000,000,000,000,000,000  ;192


 .BYTE 000,000,000,000,000,000,000,000  ;200
 .BYTE 000,000,000,000,000,000,000,000  ;208
 .BYTE 000,000,000,000,000,000,000,000  ;216
 .BYTE 000,000,000,000,000,126,000,000  ;224
 .BYTE 000,000,013,000,000,000,000,000  ;232
 .BYTE 000,000,000,000,000,000,000,000  ;240
 .BYTE 000,000,000,000,000,000,000,000  ;248
 .BYTE 000,000,000,000,000,000,000,000  ;256
;*-------------------------------
;* pet to ascii
PETTAB .BYTE 000 ;placeholder for offset
 .BYTE  000,000,000,000,000,000,000,000  ;8
 .BYTE  000,000,000,000,227,000,000,000  ;16
 .BYTE 000,000,000,000,000,000,000,000  ;24
 .BYTE 000,000,000,000,000,000,000,032  ;32
 .BYTE 033,034,035,036,037,038,039,040  ;40
 .BYTE 041,042,043,044,045,046,047,048  ;48
 .BYTE 049,050,051,052,053,054,055,056  ;56
 .BYTE 057,058,059,060,061,062,063,064  ;64

 .BYTE 097,098,099,100,101,102,103,104  ;72
 .BYTE 105,106,107,108,109,110,111,112  ;80
 .BYTE 113,114,115,116,117,118,119,120  ;88
 .BYTE 121,122,091,092,093,094,095,063  ;96
 .BYTE 065,066,067,068,069,070,071,072  ;104
 .BYTE 073,074,075,076,077,078,079,080  ;112
 .BYTE 081,082,083,084,085,086,087,088  ;120
 .BYTE 089,090,091,092,093,126,095,000  ;128

 .BYTE  000,000,000,000,000,000,000,000  ;136
 .BYTE  000,000,000,000,000,000,000,000  ;144
 .BYTE 000,000,000,000,000,000,000,000  ;152
 .BYTE 000,000,000,000,000,000,000,000  ;160
 .BYTE 000,000,000,000,000,000,000,000  ;168
 .BYTE 000,000,000,000,000,000,000,000  ;176
 .BYTE 000,000,000,000,000,000,000,000  ;184
 .BYTE 000,000,000,000,000,000,000,000  ;192

 .BYTE 065,066,067,068,069,070,071,072  ;200
 .BYTE 073,074,075,076,077,078,079,080  ;208
 .BYTE 081,082,083,084,085,086,087,088  ;216
 .BYTE 089,090,000,000,000,000,000,000  ;224
 .BYTE 000,000,013,000,000,000,000,000  ;232
 .BYTE 000,000,000,000,000,000,000,000  ;240
 .BYTE 000,000,000,000,000,000,000,000  ;248
 .BYTE 000,000,000,000,000,000,000,000  ;256

 .END

